package com.zhongzheng.modules.course.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.core.domain.entity.SysDictData;
import com.zhongzheng.common.exception.CustomException;
import com.zhongzheng.common.utils.DateUtils;
import com.zhongzheng.modules.course.bo.CourseAddBo;
import com.zhongzheng.modules.course.bo.CourseEditBo;
import com.zhongzheng.modules.course.bo.CourseQueryBo;
import com.zhongzheng.modules.course.domain.Course;
import com.zhongzheng.modules.course.mapper.CourseMapper;
import com.zhongzheng.modules.course.service.ICourseService;
import com.zhongzheng.modules.course.service.IMajorCategoryService;
import com.zhongzheng.modules.course.vo.CourseVo;
import com.zhongzheng.modules.course.vo.MajorCategoryVo;
import com.zhongzheng.modules.order.bo.CouponQueryBo;
import com.zhongzheng.modules.order.vo.CouponVo;
import com.zhongzheng.modules.system.domain.SysUserRole;
import com.zhongzheng.modules.system.mapper.SysRoleMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;

import java.util.*;
import java.util.stream.Collectors;

/**
 * 课程Service业务层处理
 *
 * @author ruoyi
 * @date 2021-05-19
 */
@Service
public class CourseServiceImpl extends ServiceImpl<CourseMapper, Course> implements ICourseService {

    @Autowired
    private CourseMapper courseMapper;

    @Autowired
    private IMajorCategoryService iMajorCategoryService;

    @Override
    public CourseVo queryById(Long courseId){
        Course db = this.baseMapper.selectById(courseId);
        if(db.getCategoryId()!=null){
            MajorCategoryVo majorCategoryVo = iMajorCategoryService.queryById(db.getCategoryId());
            db.setCategoryName(majorCategoryVo.getCategoryName());
        }
        return BeanUtil.toBean(db, CourseVo.class);
    }

    @Override
    public List<CourseVo> queryList(CourseQueryBo bo) {
        LambdaQueryWrapper<Course> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getCategoryId() != null, Course::getCategoryId, bo.getCategoryId());
        lqw.eq(bo.getPrice() != null, Course::getPrice, bo.getPrice());
        lqw.eq(bo.getDuration() != null, Course::getDuration, bo.getDuration());
        lqw.eq(bo.getStartTime() != null, Course::getStartTime, bo.getStartTime());
        lqw.eq(bo.getEndTime() != null, Course::getEndTime, bo.getEndTime());
        lqw.eq(StrUtil.isNotBlank(bo.getCoverUrl()), Course::getCoverUrl, bo.getCoverUrl());
        lqw.eq(StrUtil.isNotBlank(bo.getIntroduction()), Course::getIntroduction, bo.getIntroduction());
        lqw.in(bo.getStatus() != null, Course::getStatus, bo.getStatus());
        lqw.eq(StrUtil.isNotBlank(bo.getTeacherIds()), Course::getTeacherIds, bo.getTeacherIds());
        lqw.like(StrUtil.isNotBlank(bo.getCourseName()), Course::getCourseName, bo.getCourseName());
        lqw.orderByDesc(Course::getSort);
        return entity2Vo(this.list(lqw));
    }

    @Override
    public List<CourseVo> queryRecommendList(CourseQueryBo bo) {
        return courseMapper.queryRecommendList(bo);
    }

    @Override
    public List<CourseVo> selectCourseList(CourseQueryBo bo) {
        return courseMapper.selectCourseList(bo);
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<CourseVo> entity2Vo(Collection<Course> collection) {
        List<CourseVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, CourseVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<Course> page = (Page<Course>)collection;
            Page<CourseVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Long insertByAddBo(CourseAddBo bo) {
        Course add = BeanUtil.toBean(bo, Course.class);
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add)?add.getCourseId():0;
    }

    @Override
    public Boolean updateByEditBo(CourseEditBo bo) {
        Course update = BeanUtil.toBean(bo, Course.class);
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(Course entity){
        //TODO 做一些数据校验,如唯一约束

    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
